/**************************************************************************
;  
;  Funkce void student() v asembleru (verze pro GAS)
;  --------------------------------------------------
;   
;  Tento zdrojovy kod obsahuje nezbytnou
;  cast implementace funkce student(), ktera bude 
;  prilinkovana k main.c. V casti "... zde doplnte instrukce ..."
;  muze student dopsat jakekoliv MMX, SSE, SSE2, SSE3 instrukce podle 
;  zadaneho ukolu. 
;      
;  *** Ladici funkce pro MMX, SSE a 3DNow! ***
;  
;  Zobrazeni MMX registru (MMX, 3DNow!):
*/
	.extern print_mm_regs_pb
	.extern print_mm_regs_pw
	.extern print_mm_regs_pd
	.extern print_mm_regs_pq
	.extern print_mm_regs_fp
     
/* Funkce vytisknou vsechny MMX registry ve formatu packet byte(pb), packet
;  word (pw), packet double word (pd), packet quad word (pq) a single-precision
;  FP (fp). Vsechny funkce jsou bez parametru. Funkce _print_mm_regs_fp ma smysl 
;  pouze pro 3DNow!. Volani z asembleru napr. call _print_mm_regs_pd. Format 
;  vystupu (hexadecimalne, dekadicky se znamenkem a bez znamenka) je mozno 
;  ovlivnit parametrem spousteneho programu. Napr. ./main -cl -x zajisti
;  vystup v sestnactkove soustave. 
;   
;  Zobrazeni jednoho MMX registru:
  
;  Format packet byte (pb):
*/
	.extern print_mm0_pb
	.extern print_mm1_pb
	.extern print_mm2_pb
	.extern print_mm3_pb
	.extern print_mm4_pb
	.extern print_mm5_pb
	.extern print_mm6_pb
	.extern print_mm7_pb
	
//   Format packet word (pw):

	.extern print_mm0_pw
	.extern print_mm1_pw
	.extern print_mm2_pw
	.extern print_mm3_pw
	.extern print_mm4_pw
	.extern print_mm5_pw
	.extern print_mm6_pw
	.extern print_mm7_pw
	
//  Format packet dword (pd):

	.extern print_mm0_pd
	.extern print_mm1_pd
	.extern print_mm2_pd
	.extern print_mm3_pd
	.extern print_mm4_pd
	.extern print_mm5_pd
	.extern print_mm6_pd
	.extern print_mm7_pd
//	
//  Format packet qword (pq):
//
	.extern print_mm0_pq
	.extern print_mm1_pq
	.extern print_mm2_pq
	.extern print_mm3_pq
	.extern print_mm4_pq
	.extern print_mm5_pq
	.extern print_mm6_pq
	.extern print_mm7_pq


//  Zobrazeni XMM registru (jen SSE, SSE2, SSE3)	

	.extern print_xmm_regs
  
/* Tato funkce vytiskne vsechny XMM registry v single-precision FP formatu. 
;  Funkce nema zadne parametry.
;
;  Zobrazeni jednoho XMM registru
*/
	.extern print_xmm0
	.extern print_xmm1
	.extern print_xmm2
	.extern print_xmm3
	.extern print_xmm4
	.extern print_xmm5
	.extern print_xmm6
	.extern print_xmm7 
 
/* Tato funkce vytiskne jeden XMM registr v single-precision FP formatu. 
;  Funkce nema zadne parametry. Priklad volani z asembleru call _print_xmm0.
;  
;  *** Graficke funkce ***
;  
;  Makro  LOAD_RGB_IMAGE fn, w, h, im
;  
;  Toto makro nahraje obrazek ze souboru fn. Velikost obrazku je urcena 
;  velikosti obrazku v souboru. Velikost se uklada do promennych w a h typu
;  int. Nahrany obrazek se ulozi po radcich do pole im v RGB formatu 00bbggrr
;  (32 bitu na pixel). Velikost pole im musi byt dostatecna
;  pro ulozeni celeho obrazku (nekontroluje se). Pokud je parametr im = 0 (null),
;  pak se naplni pouze promenne w, h. To se da vyuzit ke zjisteni velikosti 
;  obrazku a naslednou kontrolu nebo alokaci pole. 
;  
;  Priklad pouziti:
;  
;    		.data 
;
; width:	.int 0
; height: 	.int 0
;
;		.bss
;
; image:	.space 100*100*4	
;        
;		.text
;		...
;		LOAD_RGB_IMAGE 1, width, height, image
;		...
;	 
;        
;  Makro  LOAD_GRAY_IMAGE fn, w, h, im
;  
;  Toto makro nahraje obrazek ze souboru fn. Velikost obrazku je urcena 
;  velikosti obrazku v souboru. Velikost se uklada do promennych w a h typu
;  int. Nahrany obrazek se ulozi po radcich do pole im ve formatu 8 bitu/pixel 
;  (256 urovni sedi). Pozor ! obrazek v souboru muze byt pouze barevny (RGB Truecolor). 
;  Velikost pole im musi byt dostatecna pro ulozeni celeho obrazku (nekontroluje se).
;  Pokud je parametr im = 0 (null), pak se naplni pouze promenne w, h. 
;  To se da vyuzit ke zjisteni velikosti obrazku a naslednou kontrolu nebo alokaci pole.
;
;  Priklad pouziti:
;  
;    		.data  
;
; width:	DD 0
; height: 	DD 0
;
; image:	RESB 100*100	
;        
;		.text
;		...
;		LOAD_GRAY_IMAGE 1, width, height, image
;		...
;
;  		Makro SHOW_RGB_IMAGE num, w, h, im      	
;   
;********************************************************************************
;          
;	Makra 
*/
	.extern load_rgb_image
	.extern load_gray_image
	.extern show_rgb_image
	.extern show_gray_image
	
	.macro LOAD_RGB_IMAGE fn, w, h, im
	sub esp, 0x10
	mov dword ptr [esp], offset \fn
	mov dword ptr [esp+0x4], offset \w
	mov dword ptr [esp+0x8], offset  \h
	mov dword ptr [esp+0xC], offset \im
	call	load_rgb_image 
	.endm

	.macro LOAD_GRAY_IMAGE fn, w, h, im
	sub esp, 0x10
	mov dword ptr [esp], offset \fn
	mov dword ptr [esp+0x4], offset \w
	mov dword ptr [esp+0x8], offset  \h
	mov dword ptr [esp+0xC], offset \im
	call	load_gray_image 
	.endm

	.macro SHOW_RGB_IMAGE num, w, h, im
	sub esp, 0x10
	mov dword ptr [esp], offset \num
	mov eax, dword ptr [\w]
	mov dword ptr [esp+0x4], eax
	mov eax, dword ptr [\h]
	mov dword ptr [esp+0x8], eax
	mov dword ptr [esp+0xc], offset \im
	call	show_rgb_image
	.endm

	.macro SHOW_GRAY_IMAGE num, w, h, im
	sub esp, 0x10
	mov dword ptr [esp], offset \num
	mov eax, dword ptr [\w]
	mov dword ptr [esp+0x4], eax
	mov eax, dword ptr [\h]
	mov dword ptr [esp+0x8], eax
	mov dword ptr [esp+0xc], offset \im
	call	show_gray_image
	.endm
	
//********************************************************************************

//	Intel-syntax mode

	.intel_syntax

//	Inicializovane promenne
	
	.data
	
fname: 	.string "image.bmp"
width:	.int 0
height:	.int 0

a:	.byte  1,  2,  3,  4,  5,  6,  7,  8
b:	.byte 10, 20, 30, 40, 50, 60, 70, 80

	.align 16
xa:	.float 1.1, 1.2, 1.3, 1.4
xb:	.float 2.1, 2.2, 2.3, 2.4

//	Neinicializovane promenne	
	
	.bss

//      Obrazek 100 x 100 pixelu
image:  .space 100 * 100 * 4  

// 	Program
		
     	.text

//	Export funkce student()

	.global student

student: 
 	// Prolog
       	push   ebp
        mov    ebp, esp

        // Telo funkce
	
	// Nulovani MMX registru 
/*
	pxor mm0, mm0
	pxor mm1, mm1
	pxor mm2, mm2
	pxor mm3, mm3
	pxor mm4, mm4
	pxor mm5, mm5
	pxor mm6, mm6
	pxor mm7, mm7
*/
	// ... zde napiste instrukce ...
/*
	
	 //  Priklad: 1 
	 // (odkomentujte nasledujici 4 radky, prelozte a
	 // spustte s parametrem -gr. [./main -gr])
	 
	 LOAD_RGB_IMAGE fname, width, height, image

	 SHOW_RGB_IMAGE 1, width, height, image 
	      	
	 LOAD_GRAY_IMAGE fname, width, height, image
	 SHOW_GRAY_IMAGE 2, width, height, image      	
*/

/*
	 // Priklad: 2
	 // (odkomentujte nasledujicich 13 radku, prelozte a
	 // spustte s parametrem -cl [./main -cl]
	
	 movq mm0, [a]
	 movq mm1, [b]
	 call _print_mm_regs_pb
	
	 paddb mm0, mm1
	 
	 call _print_mm0_pb
	 call _print_mm1_pb
	
	 psubb mm1, mm0
	 
	 call print_mm_regs_pb
*/

/*	

	// Priklad: 3
	// (odkomentujte nasledujicich 13 radku, prelozte a
	// spustte s parametrem -cl [./main -cl]
	
	movups xmm0, [xa]
	movups xmm1, [xb]
	
	call _print_xmm_regs
	addps xmm0, xmm1
	
	call _print_xmm0
	call _print_xmm1
	
	subps xmm1, xmm0
	
	call _print_xmm_regs
*/
	
	// Epilog
	leave
        ret

//**************************************************************************
