;**************************************************************************
;  
;  Funkce void student() v asembleru (verze pro NASM)
;  --------------------------------------------------
;   
;  Tento zdrojovy kod obsahuje nezbytnou
;  cast implementace funkce student(), ktera bude 
;  prilinkovana k main.c. V casti "... zde doplnte instrukce ..."
;  muze student dopsat jakekoliv MMX, SSE, SSE2, SSE3 instrukce podle 
;  zadaneho ukolu. 
;      
;  *** Ladici funkce pro MMX, SSE a 3DNow! ***
;  
;  Zobrazeni MMX registru (MMX, 3DNow!):
 
	EXTERN print_mm_regs_pb
	EXTERN print_mm_regs_pw
	EXTERN print_mm_regs_pd
	EXTERN print_mm_regs_pq
	EXTERN print_mm_regs_fp
     
;  Funkce vytisknou vsechny MMX registry ve formatu packet byte(pb), packet
;  word (pw), packet double word (pd), packet quad word (pq) a single-precision
;  FP (fp). Vsechny funkce jsou bez parametru. Funkce _print_mm_regs_fp ma smysl 
;  pouze pro 3DNow!. Volani z asembleru napr. call _print_mm_regs_pd. Format 
;  vystupu (hexadecimalne, dekadicky se znamenkem a bez znamenka) je mozno 
;  ovlivnit parametrem spousteneho programu. Napr. ./main -cl -x zajisti
;  vystup v sestnactkove soustave. 
;   
;  Zobrazeni jednoho MMX registru:
;  
;  Format packet byte (pb):
;
	EXTERN print_mm0_pb
	EXTERN print_mm1_pb
	EXTERN print_mm2_pb
	EXTERN print_mm3_pb
	EXTERN print_mm4_pb
	EXTERN print_mm5_pb
	EXTERN print_mm6_pb
	EXTERN print_mm7_pb
;	
;  Format packet word (pw):
;
	EXTERN print_mm0_pw
	EXTERN print_mm1_pw
	EXTERN print_mm2_pw
	EXTERN print_mm3_pw
	EXTERN print_mm4_pw
	EXTERN print_mm5_pw
	EXTERN print_mm6_pw
	EXTERN print_mm7_pw
;	
;  Format packet dword (pd):
;
	EXTERN print_mm0_pd
	EXTERN print_mm1_pd
	EXTERN print_mm2_pd
	EXTERN print_mm3_pd
	EXTERN print_mm4_pd
	EXTERN print_mm5_pd
	EXTERN print_mm6_pd
	EXTERN print_mm7_pd
;	
;  Format packet qword (pq):
;
	EXTERN print_mm0_pq
	EXTERN print_mm1_pq
	EXTERN print_mm2_pq
	EXTERN print_mm3_pq
	EXTERN print_mm4_pq
	EXTERN print_mm5_pq
	EXTERN print_mm6_pq
	EXTERN print_mm7_pq
;
;
;  Zobrazeni XMM registru (jen SSE, SSE2, SSE3)	
;
	EXTERN print_xmm_regs
;  
;  Tato funkce vytiskne vsechny XMM registry v single-precision FP formatu. 
;  Funkce nema zadne parametry.
;
;  Zobrazeni jednoho XMM registru
;
	EXTERN print_xmm0
	EXTERN print_xmm1
	EXTERN print_xmm2
	EXTERN print_xmm3
	EXTERN print_xmm4
	EXTERN print_xmm5
	EXTERN print_xmm6
	EXTERN print_xmm7 
;  
;  Tato funkce vytiskne jeden XMM registr v single-precision FP formatu. 
;  Funkce nema zadne parametry. Priklad volani z asembleru call _print_xmm0.
;  
;  *** Graficke funkce ***
;  
;  Makro  LOAD_RGB_IMAGE fn, w, h, im
;  
;  Toto makro nahraje obrazek ze souboru fn. Velikost obrazku je urcena 
;  velikosti obrazku v souboru. Velikost se uklada do promennych w a h typu
;  int. Nahrany obrazek se ulozi po radcich do pole im v RGB formatu 00bbggrr
;  (32 bitu na pixel). Velikost pole im musi byt dostatecna
;  pro ulozeni celeho obrazku (nekontroluje se). Pokud je parametr im = 0 (null),
;  pak se naplni pouze promenne w, h. To se da vyuzit ke zjisteni velikosti 
;  obrazku a naslednou kontrolu nebo alokaci pole. 
;  
;  Priklad pouziti:
;  
;    		SEGMENT .data 
;
; width:	DD 0
; height: 	DD 0
;
; image:	RESD 100*100	
;        
;		SEGMENT .text
;		...
;		LOAD_RGB_IMAGE num, width, height, image
;		...
;	 
;        
;  Makro  LOAD_GRAY_IMAGE fn, w, h, im
;  
;  Toto makro nahraje obrazek ze souboru fn. Velikost obrazku je urcena 
;  velikosti obrazku v souboru. Velikost se uklada do promennych w a h typu
;  int. Nahrany obrazek se ulozi po radcich do pole im ve formatu 8 bitu/pixel 
;  (256 urovni sedi). Pozor ! obrazek v souboru muze byt pouze barevny (RGB Truecolor). 
;  Velikost pole im musi byt dostatecna pro ulozeni celeho obrazku (nekontroluje se).
;  Pokud je parametr im = 0 (null), pak se naplni pouze promenne w, h. 
;  To se da vyuzit ke zjisteni velikosti obrazku a naslednou kontrolu nebo alokaci pole.
;
;  Priklad pouziti:
;  
;    		SEGMENT .data  
;
; width:	DD 0
; height: 	DD 0
;
; image:	RESB 100*100	
;        
;		SEGMENT .text
;		...
;		LOAD_GRAY_IMAGE num, width, height, image
;		...
;
;  		Makro SHOW_RGB_IMAGE num, w, h, im      	
;   
;********************************************************************************
;    
	BITS 32      
;	
;	Makra 
;
	EXTERN load_rgb_image
	EXTERN load_gray_image
	EXTERN show_rgb_image
	EXTERN show_gray_image
	
;       LOAD_RGB_IMAGE fn, w, h, im
%macro  LOAD_RGB_IMAGE 4
	sub esp, 0x10
	mov dword [esp], %1
	mov dword [esp+0x4], %2
	mov dword [esp+0x8], %3
	mov dword [esp+0xC], %4
	call	load_rgb_image 
%endmacro

;	LOAD_GRAY_IMAGE fn, w, h, im
%macro	LOAD_GRAY_IMAGE 4
	sub esp, 0x10
	mov dword [esp], %1
	mov dword [esp+0x4], %2
	mov dword [esp+0x8], %3
	mov dword [esp+0xC], %4
	call	load_gray_image 
%endmacro

;	SHOW_RGB_IMAGE num, w, h, im
%macro 	SHOW_RGB_IMAGE 4
	sub esp, 0x10
	mov dword [esp], %1
	mov eax, dword [%2]
	mov dword [esp+0x4], eax
	mov eax, dword [%3]
	mov dword [esp+0x8], eax
	mov dword [esp+0xc], %4
	call	show_rgb_image
%endmacro

;	SHOW_GRAY_IMAGE num, w, h, im
%macro 	SHOW_GRAY_IMAGE 4
	sub esp, 0x10
	mov dword [esp], %1
	mov eax, dword [%2]
	mov dword [esp+0x4], eax
	mov eax, dword [%3]
	mov dword [esp+0x8], eax
	mov dword [esp+0xc], %4
	call	show_gray_image
%endmacro


%macro SYSCALL_WRITE 2
	mov eax, 4	
	mov ebx, 1
	mov ecx, %1 ; ukazatel na napis
	mov edx, %2 ; delka napisu
	int 0x80	
%endmacro

;********************************************************************************
;
;	Inicializovane promenne
;
	SEGMENT .data

fname: 	DB "image.bmp", 0
width:	DD 0
height:	DD 0

napis: DB "Nasobeni matic:", 0xA
len_napis equ $-napis
nap_vektor: DB "Vektor:"
len_nap_vektor equ $-nap_vektor

a:	DB  1,  2,  3,  4,  5,  6,  7,  8
b:	DB 10, 20, 30, 40, 50, 60, 70, 80


xa:	DD 1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7, 1.8
xb:	DD 2.1, 2.2, 2.3, 2.4, 2.5, 2.6, 2.7, 2.0
xc: DD 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0

%define MAT_X_SIZE 4

matice: DD 1.0, 1.1, 1.2, 1.3, \
		   1.4, 1.5, 1.6, 1.7, \
		   1.8, 1.9, 2.0, 2.1, \
		   2.2, 2.3, 2.4, 2.5  


; Overeni v Matlabu, pro jistotu :)
;
;A = [ 1.0, 1.1, 1.2, 1.3 ;
;		   1.4, 1.5, 1.6, 1.7 ;
;		     1.8, 1.9, 2.0, 2.1 ;
;		   2.2, 2.3, 2.4, 2.5  ]
;
;B = [10, 20, 30,40]

;vektor: DD 2.0, 3.0, 0.5, 10.0
vektor: DD 10.0, 20.0, 30.0, 40.0

vysledek: DD 0.0, 0.0, 0.0, 0.0

;	Neinicializovane promenne	
;	
	SEGMENT .bss

trans:  RESD (MAT_X_SIZE * MAT_X_SIZE)
;
; 	Program
;		
     	SEGMENT .text
;
;	Export funkce student()
;
	GLOBAL student

student: 
 	; Prolog
       	push   ebp
        mov    ebp, esp

        ; Telo funkce
	
	; ... zde napiste instrukce ...
	
	; Priklad: 3
	; (odkomentujte nasledujicich 13 radku, prelozte a
	; spustte s parametrem -cl [./main -cl]
	; 
	 movups xmm0, [xa]
	 movups xmm1, [xb]
	 movups xmm2, [xa+4*4] 
	 movups xmm3, [xb+4*4] 

	 call print_xmm_regs
	 addps xmm0, xmm1
	 addps xmm2, xmm3
	
	 movups [xc], xmm0
	 movups [xc+4*4], xmm2

	 call print_xmm0
	 call print_xmm2
	  
	 ; ------------------------------
	 ; nasobeni matice

	SYSCALL_WRITE napis, len_napis		
	
	xorps xmm2, xmm2

	mov ebx, matice ; zacatek matice v pameti

; matice je v pameti ulozena transponovana !!!
; inspirace: http://www.cortstratton.org/articles/HugiCode.html

	movups xmm4, [ebx]
    movups xmm5, [ebx+MAT_X_SIZE*4]
    movups xmm6, [ebx+(MAT_X_SIZE*4)*2]
    movups xmm7, [ebx+(MAT_X_SIZE*4)*3]
	call print_xmm_regs

	SYSCALL_WRITE nap_vektor, len_nap_vektor		
	
	movups xmm0, [vektor]
	call print_xmm0

    ; http://courses.ece.uiuc.edu/ece390/books/labmanual/inst-ref-simd.html
    ;B.5.69 SHUFPS: Shuffle Packed Single-Precision FP Values
    ;
    ; SHUFPS xmm1,xmm2/m128,imm8    ; 0F C6 /r ib     [KATMAI,SSE]

	; SHUFPS moves two of the packed single-precision FP values from the destination
	; operand into the low quadword of the destination operand; the upper quadword is
	; generated by moving two of the single-precision FP values from the source
	; operand into the destination. The select (third) operand selects which of the
	; values are moved to the destination register.

	; The select operand is an 8-bit immediate: bits 0 and 1 select the value to be
	; moved from the destination operand the low doubleword of the result, bits 2 and
	; 3 select the value to be moved from the destination operand the second
	; doubleword of the result, bits 4 and 5 select the value to be moved from the
	; source operand the third doubleword of the result, and bits 6 and 7 select the
	; value to be moved from the source operand to the high doubleword of the result.
	
	movups  xmm1, xmm0
    shufps  xmm1, xmm1, 0x00 ; * B[1]
	call print_xmm1
    mulps   xmm1, xmm4
    addps   xmm2, xmm1
	call print_xmm2

    movups xmm1, xmm0
    shufps xmm1, xmm1, 0x55 ; * B[2]
	call print_xmm1
    mulps  xmm1, xmm5
    addps  xmm2, xmm1
	call print_xmm2

    movups xmm1, xmm0
    shufps xmm1, xmm1, 0xAA ; * B[3]
	call print_xmm1
    mulps  xmm1, xmm6
    addps  xmm2, xmm1
	call print_xmm2

    movups xmm1, xmm0
    shufps xmm1, xmm1, 0xFF ; * B[4]
	call print_xmm1
    mulps  xmm1, xmm7
    addps  xmm2, xmm1

	call print_xmm2

; | XMM2: |   2,100000e+02 |   2,000000e+02 |   1,900000e+02 |   1,800000e+02 |

; Overeni vysledku v matlabu
;>> A'*B'
;
;ans =
;
;   180
;   190
;   200
;   210

	
; call print_xmm_regs
	
	; Epilog
	leave
        ret

;**************************************************************************
